import { useMutation, useQueryClient } from "@tanstack/react-query";


import { postGweet } from "../api/post-gweet";

export const useCreateGweet = () => {
  const queryClient = useQueryClient();

  return useMutation(
    ({
      content,
      userId,
      replyToUserId,
      replyToGweetId,
    }: {
      content: string;
      userId: string;
      replyToUserId?: string | null;
      replyToGweetId?: string | null;
    }) => {
      return postGweet({
        content,
        userId,
        replyToUserId,
        replyToGweetId,
      });
    },
    {
      onSuccess: () => {
        queryClient.invalidateQueries(["gweets"]);
        queryClient.invalidateQueries(["hashtags"]);
      },
      onError: (error) => {
        console.log("error", error);
      },
    },
  );
};